searchNodes=[{"ref":"Chi2fit.Cli.html","title":"Chi2fit.Cli","module":"Chi2fit.Cli","type":"module","doc":"Provides a command line interface for fitting data against a known cumulative distribution function. Tool for fitting particular probability distributions to empirical cumulative distribution functions. Distributions supported are Weibull, Wald (Inverse Gauss), Normal, Exponential, Erlang, and Skewed Exponential. It uses the Chi-squared Pearson statistic as the likelihood function for fitting. This statistic applies to empirical data that is categorial in nature. It provides various options for controlling the fitting procedure and assignment of errors. It supports asymmetrical errors in fitting the data. Basic usage: scanning the surface As described above fitting the parameters is done by minimizing the chi-squared statistic. Usually this is a function of the distribution paremeters. Scanning the surface is a simple way to have an initial guess of the parameters. The following command does a simple scan of the chi-squared surface against data: $ chi2fit data.csv --ranges &#39;[{0.8,1.2},{0.6,1.2}]&#39; --cdf weibull Initial guess: chi2: 1399.3190035059733 pars: [0.800467783803376, 29.98940654419653] errors: {[0.800467783803376, 0.800467783803376], [29.98940654419653, 29.98940654419653]} and the file data.csv is formatted as Lead Time 26 0 105 69 3 36 ... In this form the command will scan or probe the Chi-squared surface for the parameters within the provided range. It returns the found minimum Chi-squared and the parameter values at this minimum. The reported error ranges correspond to a change of Chi-squared of +1. Options available: probes - The number of probes to use for guessing parameter values at initialization progress - Shows progress during &#39;probing&#39; (shows progress every 1000 probes) c - Mark progress every 100th probe x - Mark progress every 10th probe More options are described below and are available using the option --help. Input data options Several options control how the input data is interpreted. These are: model - determines how errors are assigned to the data points. Possible values include simple|asimple|linear data - instead of using the file for data, use this option to pass a list of data points correction - Estimate of number of events missed in the right tail of the sample An example of specifying data on the command line is: $ chi2fit --ranges &#39;[{0.8,1.2},{0.6,1.2}]&#39; --cdf weibull --data &#39;[2,3,4,5,5,4,4,7]&#39; Distribution options Distributions supported are: Wald, Weibull, Normal, Erlang, Exponential, and SEP (Skewed Exponential: 3 and 4 parameters). For the distributions of SEP (4 parameters), and SEP0 (3 parameters) the following options exist: method - Supported values are &#39;gauss|gauss2|gaus3|romberg|romberg2|romberg3&#39; Romberg integration supports the options: tolerance - The target precision for Romberg integration itermax - The maximum number of iterations to use in Romberg integration Gauss integration supports the option: npoints - The number of points to use in Gauss integration (4, 8, 16, and 32) Fitting options AFter probing the surface for an initial guess of the parameters, a fine grained search for the optimum can be done by enabling the fit procedure. The algorithm implemented assumes that the initial guess is close enough to the minimum and uses a combination of parameter estimation and Monte Carlo methods. An additional strategy is to use a so-called grid-search by changing only one parameter at a time. It selects the parameters in a round robin fashion. Using Romberg iteration and Newton root finding algorithm the parameter value minimizing chi-squared is determined while kepping the other parameters constant. Then the other parameters are varied. Especially fitting distributions with 3 or more parameters may benefit from this strategy. Options controlling these are: fit - Enables the fine-grained fitting of parameters iterations - Number of iterations to use in the optimizing the Likelihood function grid - Uses a grid search to fit one parameter at a time in a round robin fashion Sometimes the chi-squared surface is not smooth but numerically problematic to get stable. In this case smoothing the surface may help. The next option enables this feature: smoothing - Smoothing of the likelihood function with a Gaussian kernel The fitting procedures uses derivatives (first and second order) to estimate changes in the parameters that will result in a better fit. Derivaties are calculated using Romberg differentiation. The accuracy and maximum number of iterations are controlled by the options: tolerance - The target precision for Romberg integration itermax - The maximum number of iterations to use in Romberg integration Bootstrapping Bootstrapping can be enabled to estimate the errors in the parameters. The supported options are: bootstrap - Enables bootstrapping. Specifies the number of iterations to perform sample - The sample size to use from the empirical distribution Output options These options are useful for printing data for generating charts of the data: print - Outputs the empirical input data with errors included output - Outputs the fitted distribution function values at the data points surface - Outputs the Chi-squared surface to a file smoothing - Smoothing of the likelihood function with a Gaussian kernel General options Options available for scanning, fitting, and bootstrapping: debug - Outputs additional data for debugging purposes&quot; References [1] R.A. Arndt and M.H. MacGregor, Methods in Computational Physics, Vol. 6 (1966) 256-296 [2] Marius M. Nagels, Baryon-Baryon Scattering in a One-Boson-Exchange Potential Mode, PhD. Thesis, Nijmegen University, 1975 [3] Richard A. Arndt and Malcolm H. MacGregor, Determination of the Nucleon-Nucleon Elastic-Scattering Matrix. IV. Comparison of Energy-Dependent and Energy-Independent Phase-Shift Analyses, Physical Review Volume 142, Number 3, January 1966"},{"ref":"Chi2fit.Cli.html#main/0","title":"Chi2fit.Cli.main/0","module":"Chi2fit.Cli","type":"function","doc":""},{"ref":"Chi2fit.Cli.html#main/1","title":"Chi2fit.Cli.main/1","module":"Chi2fit.Cli","type":"function","doc":""},{"ref":"Chi2fit.Distribution.html","title":"Chi2fit.Distribution","module":"Chi2fit.Distribution","type":"module","doc":"Provides various distributions."},{"ref":"Chi2fit.Distribution.html#bernoulli/1","title":"Chi2fit.Distribution.bernoulli/1","module":"Chi2fit.Distribution","type":"function","doc":"The Bernoulli distribution."},{"ref":"Chi2fit.Distribution.html#coin/0","title":"Chi2fit.Distribution.coin/0","module":"Chi2fit.Distribution","type":"function","doc":"Distribution for flipping coins."},{"ref":"Chi2fit.Distribution.html#constant/1","title":"Chi2fit.Distribution.constant/1","module":"Chi2fit.Distribution","type":"function","doc":"Constant distribution."},{"ref":"Chi2fit.Distribution.html#dice/1","title":"Chi2fit.Distribution.dice/1","module":"Chi2fit.Distribution","type":"function","doc":"Distribution simulating a dice (1..6)"},{"ref":"Chi2fit.Distribution.html#dice_gk4/1","title":"Chi2fit.Distribution.dice_gk4/1","module":"Chi2fit.Distribution","type":"function","doc":"Distribution simulating the dice in the GetKanban V4 simulation game."},{"ref":"Chi2fit.Distribution.html#erlang/2","title":"Chi2fit.Distribution.erlang/2","module":"Chi2fit.Distribution","type":"function","doc":"The Erlang distribution."},{"ref":"Chi2fit.Distribution.html#erlangCDF/2","title":"Chi2fit.Distribution.erlangCDF/2","module":"Chi2fit.Distribution","type":"function","doc":"The Erlang cumulative distribution function."},{"ref":"Chi2fit.Distribution.html#exponential/1","title":"Chi2fit.Distribution.exponential/1","module":"Chi2fit.Distribution","type":"function","doc":"The exponential distribution."},{"ref":"Chi2fit.Distribution.html#exponentialCDF/1","title":"Chi2fit.Distribution.exponentialCDF/1","module":"Chi2fit.Distribution","type":"function","doc":""},{"ref":"Chi2fit.Distribution.html#frechet/2","title":"Chi2fit.Distribution.frechet/2","module":"Chi2fit.Distribution","type":"function","doc":"Fréhet or inverse Weibull distribution."},{"ref":"Chi2fit.Distribution.html#frechetCDF/2","title":"Chi2fit.Distribution.frechetCDF/2","module":"Chi2fit.Distribution","type":"function","doc":"The Fréchet distribution, also known inverse Weibull distribution."},{"ref":"Chi2fit.Distribution.html#guess/3","title":"Chi2fit.Distribution.guess/3","module":"Chi2fit.Distribution","type":"function","doc":"Guesses what distribution is likely to fit the sample data"},{"ref":"Chi2fit.Distribution.html#model/2","title":"Chi2fit.Distribution.model/2","module":"Chi2fit.Distribution","type":"function","doc":"Returns the model for a name. The kurtosis is the so-called &#39;excess kurtosis&#39;. Supported disributions: &quot;wald&quot; - The Wald or Inverse Gauss distribution, &quot;weibull&quot; - The Weibull distribution, &quot;exponential&quot; - The exponential distribution, &quot;poisson&quot; - The Poisson distribution, &quot;normal&quot; - The normal or Gaussian distribution, &quot;fechet&quot; - The Fréchet distribution, &quot;nakagami&quot; - The Nakagami distribution, &quot;sep&quot; - The Skewed Exponential Power distribution (Azzalini), &quot;erlang&quot; - The Erlang distribution, &quot;sep0&quot; - The Skewed Exponential Power distribution (Azzalini) with location parameter set to zero (0). Options Available only for the SEP distribution, see &#39;sepCDF/5&#39;."},{"ref":"Chi2fit.Distribution.html#nakagami/2","title":"Chi2fit.Distribution.nakagami/2","module":"Chi2fit.Distribution","type":"function","doc":"Nakagami distribution."},{"ref":"Chi2fit.Distribution.html#nakagamiCDF/2","title":"Chi2fit.Distribution.nakagamiCDF/2","module":"Chi2fit.Distribution","type":"function","doc":"The Nakagami distribution."},{"ref":"Chi2fit.Distribution.html#normal/2","title":"Chi2fit.Distribution.normal/2","module":"Chi2fit.Distribution","type":"function","doc":"The normal or Gauss distribution"},{"ref":"Chi2fit.Distribution.html#normalCDF/2","title":"Chi2fit.Distribution.normalCDF/2","module":"Chi2fit.Distribution","type":"function","doc":"The normal or Gauss cumulative distribution"},{"ref":"Chi2fit.Distribution.html#poisson/1","title":"Chi2fit.Distribution.poisson/1","module":"Chi2fit.Distribution","type":"function","doc":"The Poisson distribution. For the implementation, see https://en.wikipedia.org/wiki/Poisson_distribution, &#39;Generating Poisson-distributed random variables&#39;"},{"ref":"Chi2fit.Distribution.html#poissonCDF/1","title":"Chi2fit.Distribution.poissonCDF/1","module":"Chi2fit.Distribution","type":"function","doc":""},{"ref":"Chi2fit.Distribution.html#sepCDF/5","title":"Chi2fit.Distribution.sepCDF/5","module":"Chi2fit.Distribution","type":"function","doc":"The Skew Exponential Power cumulative distribution (Azzalini). Options :method - the integration method to use, :gauss and :romberg types are supported, see below :tolerance - re-iterate until the tolerance is reached (only for :romberg) :points - the number of points to use in :gauss method Integration methods :gauss - n-point Gauss rule, :gauss2 - n-point Guass rule with tanh transformation, :gauss3 - n-point Gauss rule with linear transformstion, :romberg - Romberg integration, :romberg2 - Romberg integration with tanh transformation, :romberg3 - Romberg integration with linear transformstion."},{"ref":"Chi2fit.Distribution.html#uniform/1","title":"Chi2fit.Distribution.uniform/1","module":"Chi2fit.Distribution","type":"function","doc":"Uniform distribution."},{"ref":"Chi2fit.Distribution.html#uniform/2","title":"Chi2fit.Distribution.uniform/2","module":"Chi2fit.Distribution","type":"function","doc":"Uniform distribution."},{"ref":"Chi2fit.Distribution.html#wald/2","title":"Chi2fit.Distribution.wald/2","module":"Chi2fit.Distribution","type":"function","doc":"Wald or Inverse Gauss distribution."},{"ref":"Chi2fit.Distribution.html#waldCDF/2","title":"Chi2fit.Distribution.waldCDF/2","module":"Chi2fit.Distribution","type":"function","doc":"The Wald (Inverse Gauss) cumulative distribution function."},{"ref":"Chi2fit.Distribution.html#weibull/2","title":"Chi2fit.Distribution.weibull/2","module":"Chi2fit.Distribution","type":"function","doc":"The Weibull distribution."},{"ref":"Chi2fit.Distribution.html#weibullCDF/2","title":"Chi2fit.Distribution.weibullCDF/2","module":"Chi2fit.Distribution","type":"function","doc":"The Weibull cumulative distribution function."},{"ref":"Chi2fit.Distribution.html#t:cdf/0","title":"Chi2fit.Distribution.cdf/0","module":"Chi2fit.Distribution","type":"type","doc":""},{"ref":"Chi2fit.Distribution.html#t:distribution/0","title":"Chi2fit.Distribution.distribution/0","module":"Chi2fit.Distribution","type":"type","doc":""},{"ref":"Chi2fit.Distribution.UnsupportedDistributionError.html","title":"Chi2fit.Distribution.UnsupportedDistributionError","module":"Chi2fit.Distribution.UnsupportedDistributionError","type":"exception","doc":""},{"ref":"Chi2fit.FFT.html","title":"Chi2fit.FFT","module":"Chi2fit.FFT","type":"module","doc":"Provides Fast Fourier Transform."},{"ref":"Chi2fit.FFT.html#fft/2","title":"Chi2fit.FFT.fft/2","module":"Chi2fit.FFT","type":"function","doc":"Calculates the discrete Fast Fourier Transform of a list of numbers. Provides a parallel version (see options below). See [1] for details of the algorithm implemented. Options :phase - Correction factor to use in the weights of the FFT algorithm. Defaults to 1. :nproc - Parellel version. Number of processes to use. See [2]. Defaults to 1. References [1] Zie: https://en.wikipedia.org/wiki/Cooley%E2%80%93Tukey_FFT_algorithm [2] Parallel version of FFT; see http://www.webabode.com/articles/Parallel%20FFT%20implementations.pdf Examples iex&gt; fft [4] [{4.0, 0.0}] iex&gt; fft [1,2,3,4,5,6] [{21.0, 0.0}, {-3.0000000000000053, 5.19615242270663}, {-3.0000000000000036, 1.7320508075688736}, {-3.0, 0.0}, {-2.9999999999999982, -1.7320508075688799}, {-2.999999999999991, -5.196152422706634}]"},{"ref":"Chi2fit.FFT.html#ifft/2","title":"Chi2fit.FFT.ifft/2","module":"Chi2fit.FFT","type":"function","doc":"Calculates the inverse FFT. For available options see fft/2. Examples iex&gt; ifft [4.0] [{4.0, 0.0}] iex&gt; ifft [1.0,2.0,3.0] [{2.0, 0.0}, {-0.5000000000000003, -0.2886751345948125}, {-0.4999999999999995, 0.28867513459481353}] iex&gt; [1.0,5.0] |&gt; fft |&gt; ifft [{1.0, -3.061616997868383e-16}, {5.0, 6.123233995736767e-17}]"},{"ref":"Chi2fit.FFT.html#normv/1","title":"Chi2fit.FFT.normv/1","module":"Chi2fit.FFT","type":"function","doc":"Calculates the norm of a complex number or list of complex numbers. Examples iex&gt; normv [] [] iex&gt; normv {2,3} 13 iex&gt; normv [{2,3},{1,2}] [13,5]"},{"ref":"Chi2fit.FFT.html#t:complex/0","title":"Chi2fit.FFT.complex/0","module":"Chi2fit.FFT","type":"opaque","doc":"A complex number with a real part and an imaginary part."},{"ref":"Chi2fit.FFT.html#t:real/0","title":"Chi2fit.FFT.real/0","module":"Chi2fit.FFT","type":"opaque","doc":"A real number."},{"ref":"Chi2fit.Fit.html","title":"Chi2fit.Fit","module":"Chi2fit.Fit","type":"module","doc":"Implements fitting a distribution function to sample data. It minimizes the liklihood function. Asymmetric Errors To handle asymmetric errors the module provides three ways of determining the contribution to the likelihood function: `simple` - value difference of the observable and model divided by the averaged error lower and upper bounds; `asimple` - value difference of the observable and model divided by the difference between upper/lower bound and the observed value depending on whether the model is larger or smaller than the observed value; `linear` - value difference of the observable and model divided by a linear tranformation (See below). &#39;linear&#39;: Linear transformation Linear transformation that: - is continuous in u=0, - passes through the point sigma+ at u=1, - asymptotically reaches 1-y at u-&gt;infinity - pass through the point -sigma- at u=-1, - asymptotically reaches -y at u-&gt;-infinity References [1] See https://arxiv.org/pdf/physics/0401042v1.pdf"},{"ref":"Chi2fit.Fit.html#chi2/4","title":"Chi2fit.Fit.chi2/4","module":"Chi2fit.Fit","type":"function","doc":"Calculates the Chi-squared function for a list of observables. The observables are given as a list. Each observation has an error associated with it. The errors can be either symmetric or asymmetric. A &#39;penalties&#39;-function is used to assign penalties and these contribute to the chi-squared function. It may be used to &#39;forbid&#39; certain parameter, x combinations. Options `model` - Required. Determines the contribution to chi-squared taking the asymmetric errors into account. Vaid values are `:linear`, `:simple`, and `:asimple`. See Errors below Errors `simple` - Use for asymmetric errors when the sigma+ and sigma- are close to each other `asimple` - Use for asymmetric errors when y-values are not bound. `linear` - Use this model when the y-values ar bound between 0 and 1. Linear transformation that: - is continuous in u=0, - passes through the point sigma+ at u=1, - asymptotically reaches 1-y at u-&gt;infinity - pass through the point -sigma- at u=-1, - asymptotically reaches -y at u-&gt;-infinity"},{"ref":"Chi2fit.Fit.html#chi2fit/4","title":"Chi2fit.Fit.chi2fit/4","module":"Chi2fit.Fit","type":"function","doc":"Fits observables to a known model. Returns the found minimum chi-squared value, covariance matrix, gradient at the minimum, and the corresponding parameter values including error estimates. For a good fit check the following: `chi2 per degree of freedom` - this should be about 1 or less, `gradient` - at the minimum the gradient should be zero at all directions. For asymmetric errors use the option model equal to linear. Rough chi-squared surfaces or if numerically unstable, use the option smoothing set to true. Arguments `observables` - list of measurements including errors, `model` - `{parameters, fun}`: set of initial parameter values and a function to fit against the measurements Options `onstep` - call back function; it is called with a map with keys `delta`, `chi2`, and `params`, `smoothing` - boolean value indicating whether the chi-squared is smoothened using a Gauss distribution. This is used in case the surface is rough because of numerical instabilities to smoothen the surface, `model` - The same values as in chi2/3 and chi2/4 `grid?` - Performs a grid search: per step, tries to fit only one parameter and keeps the others fixed; selects the parameter in a round-robin fashion `probes` -- a list of tuples containing the result of the `chi2probe` function. Each tuple contains the chi2 value and parameter list. Defaults to the empty list."},{"ref":"Chi2fit.Fit.html#chi2probe/4","title":"Chi2fit.Fit.chi2probe/4","module":"Chi2fit.Fit","type":"function","doc":"Probes the chi-squared surface within a certain range of the parameters. It does so by randomly selecting parameter value combinations and calculate the chi-squared for the list of observations based on the selected parameter values. This routine is used to roughly probe the chi-squared surface and perform more detailed and expensive calculations to precisely determine the minimum by chi2fit/5. Returns the minimum chi-squared found, the parameter values, and all probes that resulted in chi-squared difference less than 1 with the minimum. The parameter values found in this set correspond with the errors in determining the parameters. Options `num` or `probes` - the number of points to calculate, `mark` - progress indicator: a keyword list with keys `m`, `c`, `x`, and `*`; the value must be a call back function taking zero arguments. These are called when 1000, 100, 10, probes have been done. The value of key `*` is called when a new chi-squared minimum has been found, `smoothing` - boolean value indicating whether the chi-squared is smoothened using a Gauss distribution. This is used in case the surface is rough because of numerical instabilities to smoothen the surface, `model` - See chi2/3 and chi2/4"},{"ref":"Chi2fit.Fit.html#nopenalties/2","title":"Chi2fit.Fit.nopenalties/2","module":"Chi2fit.Fit","type":"function","doc":""},{"ref":"Chi2fit.Fit.html#t:chi2/0","title":"Chi2fit.Fit.chi2/0","module":"Chi2fit.Fit","type":"type","doc":"Chi-squared statistic"},{"ref":"Chi2fit.Fit.html#t:cov/0","title":"Chi2fit.Fit.cov/0","module":"Chi2fit.Fit","type":"type","doc":"Covariance matrix"},{"ref":"Chi2fit.Fit.html#t:distribution/0","title":"Chi2fit.Fit.distribution/0","module":"Chi2fit.Fit","type":"type","doc":"Cumulative distribution mapping &#39;x&#39; and parameters to a float in the range [0,1]."},{"ref":"Chi2fit.Fit.html#t:model/0","title":"Chi2fit.Fit.model/0","module":"Chi2fit.Fit","type":"type","doc":"Tuple describing the parameter values and the distribution function."},{"ref":"Chi2fit.Fit.html#t:observable/0","title":"Chi2fit.Fit.observable/0","module":"Chi2fit.Fit","type":"type","doc":""},{"ref":"Chi2fit.Fit.html#t:observable_asym/0","title":"Chi2fit.Fit.observable_asym/0","module":"Chi2fit.Fit","type":"type","doc":"Observation with asymmetric bounds &#39;y1 &lt; y &lt; y2&#39;."},{"ref":"Chi2fit.Fit.html#t:observable_symm/0","title":"Chi2fit.Fit.observable_symm/0","module":"Chi2fit.Fit","type":"type","doc":"Observation with symmetric errors &#39;dy&#39;."},{"ref":"Chi2fit.Fit.html#t:observables/0","title":"Chi2fit.Fit.observables/0","module":"Chi2fit.Fit","type":"type","doc":""},{"ref":"Chi2fit.Fit.html#t:params/0","title":"Chi2fit.Fit.params/0","module":"Chi2fit.Fit","type":"type","doc":"List of parameter ranges"},{"ref":"Chi2fit.Matrix.html","title":"Chi2fit.Matrix","module":"Chi2fit.Matrix","type":"module","doc":"This module provides matrix inverse operations and supporting functions. It provides 2 types of matrix norms and an iterative approach to calculating the matrix inverse. The implementation is based on the work [1]. References [1] F. Soleymani, A Rapid Numerical Algorithm to Compute Matrix Inversion, International Journal of Mathematics and Mathematical Sciences, Volume 2012, Article ID 134653, doi:10.1155/2012/134653"},{"ref":"Chi2fit.Matrix.html#diagonal/1","title":"Chi2fit.Matrix.diagonal/1","module":"Chi2fit.Matrix","type":"function","doc":"Returns the diagonal elements of the matrix as a vector. Example iex&gt; diagonal [[1,2,3],[4,5,6],[7,8,9]] [1, 5, 9]"},{"ref":"Chi2fit.Matrix.html#dotproduct/2","title":"Chi2fit.Matrix.dotproduct/2","module":"Chi2fit.Matrix","type":"function","doc":"Calculates the inner product of two vectors. Examples iex&gt; dotproduct [1,2], [3,4] 11 iex&gt; dotproduct [], [] 0 iex&gt; dotproduct [1,2], [] ** (ArgumentError) Vectors of unequal length iex&gt; dotproduct [1,2], [1] ** (ArgumentError) Vectors of unequal length"},{"ref":"Chi2fit.Matrix.html#from_diagonal/1","title":"Chi2fit.Matrix.from_diagonal/1","module":"Chi2fit.Matrix","type":"function","doc":"Returns a matrix with the supplied vector as its diagonal elements. Examples iex&gt; from_diagonal [1,5,9] [[1, 0, 0], [0, 5, 0], [0, 0, 9]]"},{"ref":"Chi2fit.Matrix.html#inverse/2","title":"Chi2fit.Matrix.inverse/2","module":"Chi2fit.Matrix","type":"function","doc":"Returns the matrix inverse of the argument. Options :tolerance - Iterate until the norm_1/1 of I-AV is less than this value :algorithm - Four algorithms are supported: :hotelling_bodewig (second order), :lie (third order), :krishnamurthy_sen (sixth order), and :soleymani (seventh order); defaults to :lie :max_iterations - Maximum number of iterations to perform; defaults to 500 :range - Range of values from -range to +range as a multiple of the unit matrix to try as an estimate of the inverse matric; defaults to 100 :size - Number of tries to estimate initial inverse; defautls to 100 Examples iex&gt; inverse [[3]] {:ok,[[0.3333333333333333]]} iex&gt; inverse [[1,2],[3,4]] {:ok,[[-2.0, 1.0], [1.5, -0.5]]} iex&gt; inverse [[3,2,0],[0,0,1],[2,-2,1]] {:ok, [[0.2000000000000267, -0.19999999999873883, 0.1999999999998383], [0.19999999999995877, 0.29999999999804805, -0.29999999999974974], [-1.204377690852969e-13, 0.9999999999943042, 7.3034853221406e-13]]} iex&gt; inverse [[3,2,0],[0,0,1],[2,-2,1]], algorithm: :soleymani {:ok, [[0.2000000000000003, -0.19999999999999973, 0.19999999999999926], [0.2000000000000003, 0.29999999999999966, -0.29999999999999893], [-6.617444900424221e-23, 0.9999999999999988, -1.1183551388713516e-21]]} iex&gt; inverse [[3,2,0],[0,0,1],[2,-2,1]], tolerance: 1.0e-15 {:ok, [[0.20000000000000004, -0.2, 0.2], [0.20000000000000004, 0.3, -0.3], [-5.048709793414476e-29, 0.9999999999999999, -1.6087621596054126e-28]]} For matrices that have no inverse: iex&gt; try do inverse [[1,2,3],[4,5,6],[7,8,9]] catch x-&gt;x end :no_inverse"},{"ref":"Chi2fit.Matrix.html#norm/1","title":"Chi2fit.Matrix.norm/1","module":"Chi2fit.Matrix","type":"function","doc":"Calculates the norm of the matrix as the sum of the absolutes value of all elements. Example iex&gt; norm [[1,2,3],[4,5,6],[7,8,9]] 45"},{"ref":"Chi2fit.Matrix.html#norm_1/1","title":"Chi2fit.Matrix.norm_1/1","module":"Chi2fit.Matrix","type":"function","doc":"Calculates the norm of the matrix. All absolute values of the elements of each row are summed. The maximum value is returned Example iex&gt; norm_1 [[1,2,3],[4,5,6],[7,8,9]] 24"},{"ref":"Chi2fit.Matrix.html#norm_inf/1","title":"Chi2fit.Matrix.norm_inf/1","module":"Chi2fit.Matrix","type":"function","doc":"Calculates the norm of the matrix as norm_1/1 but over the columns instead of over the rows. Example iex&gt; norm_inf [[1,2,3],[4,5,6],[7,8,9]] 18"},{"ref":"Chi2fit.Matrix.html#unit/1","title":"Chi2fit.Matrix.unit/1","module":"Chi2fit.Matrix","type":"function","doc":"Constructs a unit matrix of size n. All diagonal elements have value 1 and the rest has value 0. Examples iex&gt; unit(3) [[1, 0, 0], [0, 1, 0], [0, 0, 1]] iex&gt; unit(0) ** (ArgumentError) Illegal argument &#39;0&#39; iex&gt; unit -1 ** (ArgumentError) Illegal argument &#39;-1&#39; iex&gt; unit 1.3 ** (ArgumentError) Illegal argument &#39;1.3&#39;"},{"ref":"Chi2fit.Matrix.html#t:matrix/0","title":"Chi2fit.Matrix.matrix/0","module":"Chi2fit.Matrix","type":"type","doc":"A list of vectors (list of lists of numbers)"},{"ref":"Chi2fit.Matrix.html#t:vector/0","title":"Chi2fit.Matrix.vector/0","module":"Chi2fit.Matrix","type":"type","doc":"A list of numbers"},{"ref":"Chi2fit.Roots.html","title":"Chi2fit.Roots","module":"Chi2fit.Roots","type":"module","doc":"Solves roots for linear, quadratic, and cubic equations."},{"ref":"Chi2fit.Roots.html#solve/1","title":"Chi2fit.Roots.solve/1","module":"Chi2fit.Roots","type":"function","doc":"Returns the real roots of polynoms of order 1, 2 and 3 as a list. Examples Solve `2.0*x + 5.0 = 0` iex&gt; solve [2.0,5.0] [-2.5] iex&gt; solve [2.0,-14.0,24.0] [4.0,3.0] iex&gt; solve [1.0,0.0,5.0,6.0] [-0.9999999999999999]"},{"ref":"Chi2fit.Utilities.html","title":"Chi2fit.Utilities","module":"Chi2fit.Utilities","type":"module","doc":"Provides various utilities: Bootstrapping Derivatives Creating Cumulative Distribution Functions / Histograms from sample data Solving linear, quadratic, and cubic equations Autocorrelation coefficients"},{"ref":"Chi2fit.Utilities.html#auto/2","title":"Chi2fit.Utilities.auto/2","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the autocorrelation coefficient of a list of observations. The implementation uses the discrete Fast Fourier Transform to calculate the autocorrelation. For available options see Chi2fit.FFT.fft/2. Returns a list of the autocorrelation coefficients. Example iex&gt; auto [1,2,3] [14.0, 7.999999999999999, 2.999999999999997]"},{"ref":"Chi2fit.Utilities.html#bootstrap/4","title":"Chi2fit.Utilities.bootstrap/4","module":"Chi2fit.Utilities","type":"function","doc":"Implements bootstrapping procedure as resampling with replacement. It supports saving intermediate results to a file using :dets. Use the options :safe and :filename (see below) Arguments: `total` - Total number resmaplings to perform `data` - The sample data `fun` - The function to evaluate `options` - A keyword list of options, see below. Options `:safe` - Whether to safe intermediate results to a file, so as to support continuation when it is interrupted. Valid values are `:safe` and `:cont`. `:filename` - The filename to use for storing intermediate results"},{"ref":"Chi2fit.Utilities.html#convert_cdf/1","title":"Chi2fit.Utilities.convert_cdf/1","module":"Chi2fit.Utilities","type":"function","doc":"Converts a CDF function to a list of data points. Example iex&gt; convert_cdf {fn x-&gt;{:math.exp(-x),:math.exp(-x)/16,:math.exp(-x)/4} end, {1,4}} [{1, 0.36787944117144233, 0.022992465073215146, 0.09196986029286058}, {2, 0.1353352832366127, 0.008458455202288294, 0.033833820809153176}, {3, 0.049787068367863944, 0.0031116917729914965, 0.012446767091965986}, {4, 0.01831563888873418, 0.0011447274305458862, 0.004578909722183545}]"},{"ref":"Chi2fit.Utilities.html#cullen_frey/2","title":"Chi2fit.Utilities.cullen_frey/2","module":"Chi2fit.Utilities","type":"function","doc":"Generates a Cullen &amp; Frey plot for the sample data. The kurtosis returned is the &#39;excess kurtosis&#39;."},{"ref":"Chi2fit.Utilities.html#cullen_frey_point/1","title":"Chi2fit.Utilities.cullen_frey_point/1","module":"Chi2fit.Utilities","type":"function","doc":"Extracts data point with standard deviation from Cullen &amp; Frey plot data."},{"ref":"Chi2fit.Utilities.html#der/3","title":"Chi2fit.Utilities.der/3","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the partial derivative of a function and returns the value. Examples The function value at a point: iex&gt; der([3.0], fn [x]-&gt; x*x end) |&gt; Float.round(3) 9.0 The first derivative of a function at a point: iex&gt; der([{3.0,1}], fn [x]-&gt; x*x end) |&gt; Float.round(3) 6.0 The second derivative of a function at a point: iex&gt; der([{3.0,2}], fn [x]-&gt; x*x end) |&gt; Float.round(3) 2.0 Partial derivatives with respect to two variables: iex&gt; der([{2.0,1},{3.0,1}], fn [x,y] -&gt; 3*x*x*y end) |&gt; Float.round(3) 12.0"},{"ref":"Chi2fit.Utilities.html#empirical_cdf/4","title":"Chi2fit.Utilities.empirical_cdf/4","module":"Chi2fit.Utilities","type":"function","doc":"Generates an empirical Cumulative Distribution Function from sample data. Three parameters determine the resulting empirical distribution: 1) algorithm for assigning errors, 2) the size of the bins, 3) a correction for limiting the bounds on the &#39;y&#39; values When e.g. task effort/duration is modeled, some tasks measured have 0 time. In practice what is actually is meant, is that the task effort is between 0 and 1 hour. This is where binning of the data happens. Specify a size of the bins to control how this is done. A bin size of 1 means that 0 effort will be mapped to 1/2 effort (at the middle of the bin). This also prevents problems when the fited distribution cannot cope with an effort os zero. Supports two ways of assigning errors: Wald score or Wilson score. See [1]. Valie values for the algorithm argument are :wald or :wilson. In the handbook of MCMC [1] a cumulative distribution is constructed. For the largest &#39;x&#39; value in the sample, the &#39;y&#39; value is exactly one (1). In combination with the Wald score this gives zero errors on the value &#39;1&#39;. If the resulting distribution is used to fit a curve this may give an infinite contribution to the maximum likelihood function. Use the correction number to have a &#39;y&#39; value of slightly less than 1 to prevent this from happening. Especially the combination of 0 correction, algorithm :wald, and &#39;linear&#39; model for handling asymmetric errors gives problems. The algorithm parameter determines how the errors onthe &#39;y&#39; value are determined. Currently supported values include :wald and :wilson. References [1] &quot;Handbook of Monte Carlo Methods&quot; by Kroese, Taimre, and Botev, section 8.4 [2] See https://en.wikipedia.org/wiki/Cumulative_frequency_analysis [3] https://arxiv.org/pdf/1112.2593v3.pdf [4] See https://en.wikipedia.org/wiki/Student%27s_t-distribution: 90% confidence ==&gt; t = 1.645 for many data points (&gt; 120) 70% confidence ==&gt; t = 1.000"},{"ref":"Chi2fit.Utilities.html#error/2","title":"Chi2fit.Utilities.error/2","module":"Chi2fit.Utilities","type":"function","doc":"Calculates and returns the error associated with a list of observables. Usually these are the result of a Markov Chain Monte Carlo simulation run. The only supported method is the so-called Initial Sequence Method. See section 1.10.2 (Initial sequence method) of [1]. Input is a list of autocorrelation coefficients. This may be the output of auto/2. References [1] &#39;Handbook of Markov Chain Monte Carlo&#39;"},{"ref":"Chi2fit.Utilities.html#get_cdf/4","title":"Chi2fit.Utilities.get_cdf/4","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the empirical CDF from a sample. Convenience function that chains make_histogram/2 and empirical_cdf/3."},{"ref":"Chi2fit.Utilities.html#integrate/5","title":"Chi2fit.Utilities.integrate/5","module":"Chi2fit.Utilities","type":"function","doc":"Numerical integration providing Gauss and Romberg types."},{"ref":"Chi2fit.Utilities.html#jacobian/3","title":"Chi2fit.Utilities.jacobian/3","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the jacobian of the function at the point x. Examples iex&gt; jacobian([2.0,3.0], fn [x,y] -&gt; x*y end) |&gt; Enum.map(&amp;Float.round(&amp;1)) [3.0, 2.0]"},{"ref":"Chi2fit.Utilities.html#make_histogram/3","title":"Chi2fit.Utilities.make_histogram/3","module":"Chi2fit.Utilities","type":"function","doc":"Converts a list of numbers to frequency data. The data is divided into bins of size binsize and the number of data points inside a bin are counted. A map is returned with the bin&#39;s index as a key and as value the number of data points in that bin. Examples iex&gt; make_histogram [1,2,3] [{1, 1}, {2, 1}, {3, 1}] iex&gt; make_histogram [1,2,3], 1.0, 0 [{1, 1}, {2, 1}, {3, 1}] iex&gt; make_histogram [1,2,3,4,5,6,5,4,3,4,5,6,7,8,9] [{1, 1}, {2, 1}, {3, 2}, {4, 3}, {5, 3}, {6, 2}, {7, 1}, {8, 1}, {9, 1}] iex&gt; make_histogram [1,2,3,4,5,6,5,4,3,4,5,6,7,8,9], 3, 1.5 [{0, 1}, {1, 6}, {2, 6}, {3, 2}]"},{"ref":"Chi2fit.Utilities.html#moment/2","title":"Chi2fit.Utilities.moment/2","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the nth moment of the sample. Example iex&gt; moment [1,2,3,4,5,6], 1 3.5"},{"ref":"Chi2fit.Utilities.html#momentc/2","title":"Chi2fit.Utilities.momentc/2","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the nth centralized moment of the sample. Example iex&gt; momentc [1,2,3,4,5,6], 1 0.0 iex&gt; momentc [1,2,3,4,5,6], 2 2.9166666666666665"},{"ref":"Chi2fit.Utilities.html#momentc/3","title":"Chi2fit.Utilities.momentc/3","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the nth centralized moment of the sample. Example iex&gt; momentc [1,2,3,4,5,6], 2, 3.5 2.9166666666666665"},{"ref":"Chi2fit.Utilities.html#momentn/2","title":"Chi2fit.Utilities.momentn/2","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the nth normalized moment of the sample. Example iex&gt; momentn [1,2,3,4,5,6], 1 0.0 iex&gt; momentn [1,2,3,4,5,6], 2 1.0 iex&gt; momentn [1,2,3,4,5,6], 4 1.7314285714285718"},{"ref":"Chi2fit.Utilities.html#momentn/3","title":"Chi2fit.Utilities.momentn/3","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the nth normalized moment of the sample. Example iex&gt; momentn [1,2,3,4,5,6], 4, 3.5 1.7314285714285718"},{"ref":"Chi2fit.Utilities.html#momentn/4","title":"Chi2fit.Utilities.momentn/4","module":"Chi2fit.Utilities","type":"function","doc":"Calculates the nth normalized moment of the sample."},{"ref":"Chi2fit.Utilities.html#newton/5","title":"Chi2fit.Utilities.newton/5","module":"Chi2fit.Utilities","type":"function","doc":"Newton-Fourier method for locating roots and returning the interval where the root is located. See [https://en.wikipedia.org/wiki/Newton%27s_method#Newton.E2.80.93Fourier_method]"},{"ref":"Chi2fit.Utilities.html#puiseaux/3","title":"Chi2fit.Utilities.puiseaux/3","module":"Chi2fit.Utilities","type":"function","doc":"Converts the input so that the result is a Puiseaux diagram, that is a strict convex shape. Examples iex&gt; puiseaux [1] [1] iex&gt; puiseaux [5,3,3,2] [5, 3, 2.5, 2]"},{"ref":"Chi2fit.Utilities.html#puts_errors/2","title":"Chi2fit.Utilities.puts_errors/2","module":"Chi2fit.Utilities","type":"function","doc":"Outputs and formats the errors that result from a call to chi2/4 Errors are tuples of length 2 and larger: {[min1,max1], [min2,max2], ...}."},{"ref":"Chi2fit.Utilities.html#read_data/1","title":"Chi2fit.Utilities.read_data/1","module":"Chi2fit.Utilities","type":"function","doc":"Reads data from a file specified by filename and returns a stream with the data parsed as floats. It expects a single data point on a separate line and removes entries that: are not floats, and smaller than zero (0)"},{"ref":"Chi2fit.Utilities.html#richardson/5","title":"Chi2fit.Utilities.richardson/5","module":"Chi2fit.Utilities","type":"function","doc":"Richardson extrapolation."},{"ref":"Chi2fit.Utilities.html#to_bins/2","title":"Chi2fit.Utilities.to_bins/2","module":"Chi2fit.Utilities","type":"function","doc":"Converts raw data to binned data with (asymmetrical) errors."},{"ref":"Chi2fit.Utilities.html#unzip/1","title":"Chi2fit.Utilities.unzip/1","module":"Chi2fit.Utilities","type":"function","doc":"Unzips lists of 1-, 2-, 3-, 4-, and 5-tuples."},{"ref":"Chi2fit.Utilities.html#t:algorithm/0","title":"Chi2fit.Utilities.algorithm/0","module":"Chi2fit.Utilities","type":"type","doc":"Algorithm used to assign errors to frequencey data: Wald score and Wilson score."},{"ref":"Chi2fit.Utilities.html#t:cdf/0","title":"Chi2fit.Utilities.cdf/0","module":"Chi2fit.Utilities","type":"type","doc":"Cumulative Distribution Function"},{"ref":"Chi2fit.Utilities.html#t:cullenfrey/0","title":"Chi2fit.Utilities.cullenfrey/0","module":"Chi2fit.Utilities","type":"type","doc":""},{"ref":"Chi2fit.Utilities.html#t:method/0","title":"Chi2fit.Utilities.method/0","module":"Chi2fit.Utilities","type":"type","doc":"Supported numerical integration methods"},{"ref":"Chi2fit.Utilities.html#t:range/0","title":"Chi2fit.Utilities.range/0","module":"Chi2fit.Utilities","type":"type","doc":""},{"ref":"Chi2fit.Utilities.UnknownSampleErrorAlgorithmError.html","title":"Chi2fit.Utilities.UnknownSampleErrorAlgorithmError","module":"Chi2fit.Utilities.UnknownSampleErrorAlgorithmError","type":"exception","doc":""}]